%define DATE 200511111
%define oprofile_version 0.9.2
%define oprofile_release 0.2
Summary: System wide profiler
Name: oprofile
Version: 0.9.2
Release: %{oprofile_release}.be0625.2.20061128
License: GPL
Group: Development/System
#
Source0: oprofile-%{version}.tar.gz
Requires: binutils
Requires: which
# Cell support
Patch1:oprofile-0.9.2-cell.patch
#
Patch2: oprofile-0.9.2-guess2.patch
Patch3: oprofile-0.9.2-libs.patch
#
#Adds xml formatting to opreport
Patch4: oprofile-0.9.2-xml.patch
#
#Adds copyright to prolog of events and unit_masks files
Patch5: oprofile-0.9.2-cell-copyright.patch


URL: http://oprofile.sf.net
ExclusiveArch: %{ix86} ia64 x86_64 ppc ppc64 s390 s390x alpha alphaev6 sparc sparc64
#BuildPreReq: qt-devel
#BuildPreReq: libxslt
#BuildPreReq: docbook-style-xsl
#BuildPreReq: docbook-utils
#BuildPreReq: elinks
#BuildPreReq: gtk2-devel
#BuildPreReq: automake

BuildRoot: %{_tmppath}/%{name}-root

%description
oprofile is a profiling system for systems running Linux 2.2/2.4/2.6.
Profiling runs transparently during the background, and profile data
can be collected at any time. oprofile makes use of the hardware performance
counters provided on Intel P6, AMD Athlon family, and other processors, and can use
the RTC for profiling on other x86 processor types.

See the HTML documentation for further details.

%package devel
Summary: Header files and libraries for developing apps which will use oprofile.
Group: Development/Libraries
Requires: oprofile = %{version}-%{release}

%description devel

Header files and libraries for developing apps which will use oprofile.

%prep
%setup -q -n %{name}-%{version}
%patch1 -p1 -b .cell
%patch2 -p1 -b .guess2
%patch3 -p1 -b .libs
%patch4 -p1 -b .xml-output
%patch5 -p1 -b .copyright

./autogen.sh

%build
#QTDIR=%{_libdir}/qt-3.3;     export QTDIR

#The CXXFLAGS below is temporary to work around
# bugzilla #113909
CXXFLAGS="-g -m32";     export CXXFLAGS
CFLAGS="%{optflags} -m32";     export CFLAGS

%define _libdir /usr/lib
./configure \
	--with-kernel-support \
        --host=%{_host} --target=%{_target_platform} --build=%{_build} \
	--program-prefix= \
        --prefix=%{_prefix} \
        --exec-prefix=%{_exec_prefix} \
        --bindir=%{_bindir} \
        --sbindir=%{_sbindir} \
        --sysconfdir=%{_sysconfdir} \
        --datadir=%{_datadir} \
        --includedir=%{_includedir} \
        --libdir=%{_libdir} \
        --libexecdir=%{_libexecdir} \
        --localstatedir=%{_localstatedir} \
        --sharedstatedir=%{_sharedstatedir} \
        --mandir=%{_mandir} \
        --infodir=%{_infodir} \
	--with-separate-debug-dir=/usr/lib/debug \
	--enable-abi

make CFLAGS="$RPM_OPT_FLAGS"

%install
rm -rf ${RPM_BUILD_ROOT}

mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man1

make DESTDIR=${RPM_BUILD_ROOT} install

#the following is an ugly hack
rm -rf ${RPM_BUILD_ROOT}/usr/share/doc/oprofile
rm -rf ${RPM_BUILD_ROOT}/usr/share/mangled-name

#hack to make header files available
mkdir -p ${RPM_BUILD_ROOT}%{_includedir}
install -m 755 libop/op_events.h $RPM_BUILD_ROOT/%{_includedir}
install -m 755 libop/op_cpu_type.h $RPM_BUILD_ROOT/%{_includedir}
#install -m 755 libop/op_events_desc.h $RPM_BUILD_ROOT/%{_includedir}
install -m 755 libop/op_config.h $RPM_BUILD_ROOT/%{_includedir}
install -m 755 libop/op_sample_file.h $RPM_BUILD_ROOT/%{_includedir}
install -m 755 libutil/op_types.h $RPM_BUILD_ROOT/%{_includedir}
install -m 755 libutil/op_list.h $RPM_BUILD_ROOT/%{_includedir}
install -m 755 libdb/odb.h $RPM_BUILD_ROOT/%{_includedir}

#hack to make .a files available
mkdir -p ${RPM_BUILD_ROOT}%{_libdir}
install -m 755 libop/libop.a $RPM_BUILD_ROOT/%{_libdir}
install -m 755 libdb/libodb.a $RPM_BUILD_ROOT/%{_libdir}
install -m 755 libutil/liboputil.a $RPM_BUILD_ROOT/%{_libdir}
install -m 755 libutil++/liboputil++.a $RPM_BUILD_ROOT/%{_libdir}
#install -m 755 pp/liboppp.a $RPM_BUILD_ROOT/%{_libdir}
install -m 755 libabi/libopabi.a $RPM_BUILD_ROOT/%{_libdir}

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(-,root,root)
%doc doc/oprofile.html

%{_bindir}/oprof_start
%{_bindir}/ophelp
%{_bindir}/opimport
%{_bindir}/opannotate
%{_bindir}/opcontrol
%{_bindir}/opgprof
%{_bindir}/opreport
%{_bindir}/oprofiled
%{_bindir}/oparchive

%{_mandir}/man1/ophelp.1.gz
%{_mandir}/man1/opannotate.1.gz
%{_mandir}/man1/opcontrol.1.gz
%{_mandir}/man1/opgprof.1.gz
%{_mandir}/man1/opreport.1.gz
%{_mandir}/man1/oprofile.1.gz
%{_mandir}/man1/oparchive.1.gz
%{_mandir}/man1/opimport.1.gz

/usr/share/oprofile/i386/core/events
/usr/share/oprofile/i386/core/unit_masks
/usr/share/oprofile/i386/core_2/events
/usr/share/oprofile/i386/core_2/unit_masks
/usr/share/oprofile/mips/20K/events
/usr/share/oprofile/mips/20K/unit_masks
/usr/share/oprofile/mips/25K/events
/usr/share/oprofile/mips/25K/unit_masks
/usr/share/oprofile/mips/34K/events
/usr/share/oprofile/mips/34K/unit_masks
/usr/share/oprofile/mips/5K/events
/usr/share/oprofile/mips/5K/unit_masks
/usr/share/oprofile/ppc/7450/events
/usr/share/oprofile/ppc/7450/unit_masks
/usr/share/oprofile/ppc/e500v2/events
/usr/share/oprofile/ppc/e500v2/unit_masks
/usr/share/oprofile/ppc64/power5+/event_mappings
/usr/share/oprofile/ppc64/power5+/events
/usr/share/oprofile/ppc64/power5+/unit_masks
/usr/share/oprofile/alpha/ev4/events
/usr/share/oprofile/alpha/ev4/unit_masks
/usr/share/oprofile/alpha/ev5/events
/usr/share/oprofile/alpha/ev5/unit_masks
/usr/share/oprofile/alpha/ev6/events
/usr/share/oprofile/alpha/ev6/unit_masks
/usr/share/oprofile/alpha/ev67/events
/usr/share/oprofile/alpha/ev67/unit_masks
/usr/share/oprofile/alpha/pca56/events
/usr/share/oprofile/alpha/pca56/unit_masks
/usr/share/oprofile/arm/xscale1/events
/usr/share/oprofile/arm/xscale1/unit_masks
/usr/share/oprofile/arm/xscale2/events
/usr/share/oprofile/arm/xscale2/unit_masks
/usr/share/oprofile/i386/athlon/events
/usr/share/oprofile/i386/athlon/unit_masks
/usr/share/oprofile/i386/p4-ht/events
/usr/share/oprofile/i386/p4-ht/unit_masks
/usr/share/oprofile/i386/p4/events
/usr/share/oprofile/i386/p4/unit_masks
/usr/share/oprofile/i386/p6_mobile/events
/usr/share/oprofile/i386/p6_mobile/unit_masks
/usr/share/oprofile/i386/pii/events
/usr/share/oprofile/i386/pii/unit_masks
/usr/share/oprofile/i386/piii/events
/usr/share/oprofile/i386/piii/unit_masks
/usr/share/oprofile/i386/ppro/events
/usr/share/oprofile/i386/ppro/unit_masks
/usr/share/oprofile/ia64/ia64/events
/usr/share/oprofile/ia64/ia64/unit_masks
/usr/share/oprofile/ia64/itanium/events
/usr/share/oprofile/ia64/itanium/unit_masks
/usr/share/oprofile/ia64/itanium2/events
/usr/share/oprofile/ia64/itanium2/unit_masks
/usr/share/oprofile/rtc/events
/usr/share/oprofile/rtc/unit_masks
/usr/share/oprofile/stl.pat
/usr/share/oprofile/x86-64/hammer/events
/usr/share/oprofile/x86-64/hammer/unit_masks
/usr/share/oprofile/ppc64/power4/event_mappings
/usr/share/oprofile/ppc64/power4/events
/usr/share/oprofile/ppc64/power4/unit_masks
/usr/share/oprofile/ppc64/power5/event_mappings
/usr/share/oprofile/ppc64/power5/events
/usr/share/oprofile/ppc64/power5/unit_masks
/usr/share/oprofile/ppc64/970/event_mappings
/usr/share/oprofile/ppc64/970/events
/usr/share/oprofile/ppc64/970/unit_masks
/usr/share/oprofile/ppc64/cell-be/events
/usr/share/oprofile/ppc64/cell-be/unit_masks
/usr/share/oprofile/mips/r10000/events
/usr/share/oprofile/mips/r10000/unit_masks
/usr/share/oprofile/mips/r12000/events
/usr/share/oprofile/mips/r12000/unit_masks
/usr/share/oprofile/mips/rm7000/events
/usr/share/oprofile/mips/rm7000/unit_masks
/usr/share/oprofile/mips/rm9000/events
/usr/share/oprofile/mips/rm9000/unit_masks
/usr/share/oprofile/mips/sb1/events
/usr/share/oprofile/mips/sb1/unit_masks
/usr/share/oprofile/mips/vr5432/events
/usr/share/oprofile/mips/vr5432/unit_masks
/usr/share/oprofile/mips/vr5500/events
/usr/share/oprofile/mips/vr5500/unit_masks
/usr/share/oprofile/ppc/e500/events
/usr/share/oprofile/ppc/e500/unit_masks
/usr/share/oprofile/mips/24K/events
/usr/share/oprofile/mips/24K/unit_masks

%files devel
%defattr(-,root,root)

%{_includedir}/odb.h
%{_includedir}/op_config.h
%{_includedir}/op_cpu_type.h
%{_includedir}/op_events.h
%{_includedir}/op_list.h
%{_includedir}/op_sample_file.h
%{_includedir}/op_types.h

%{_libdir}/libodb.a
%{_libdir}/libop.a
%{_libdir}/libopabi.a
%{_libdir}/liboputil++.a
%{_libdir}/liboputil.a


%changelog
* Tue Nov 28 2006 Maynard Johnson <maynardj@us.ibm.com> - 0.9.2-0.2
  Added copyright statement to events and unit_masks files;
  also some minor comment cleanups in the same files.

* Sun Nov 19 2006 Maynard Johnson <maynardj@us.ibm.com> - 0.9.2-0.2
  Refreshed oprofile-0.9.2-xml.patch to match what was accepted into
  OProfile CVS by the maintainer on Nov 17, 2006.

* Tue Nov 07 2006 Maynard Johnson <maynardj@us.ibm.com> - 0.9.2-0.2

* Fri Sep 22 2006 Maynard Johnson <maynardj@us.ibm.com> - 0.9.2-0.1
  Rebase on 0.9.2.
